unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Menus,NNNetworkLibrary,unit2;

const
    plrCnt=8;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    Open: TMenuItem;
    Join: TMenuItem;
    N2: TMenuItem;
    Close: TMenuItem;
    Leave: TMenuItem;
    list: TListBox;
    Splitter1: TSplitter;
    Panel1: TPanel;
    view: TMemo;
    res: TMemo;
    Panel2: TPanel;
    send: TButton;
    Splitter3: TSplitter;
    name: TEdit;
    N4: TMenuItem;
    ID1: TMenuItem;
    MainTimer: TTimer;
    N3: TMenuItem;
    N5: TMenuItem;
    Enter2: TMenuItem;
    Enter1: TMenuItem;
    procedure ID1Click(Sender: TObject);
    procedure MainTimerTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenClick(Sender: TObject);
    procedure CloseClick(Sender: TObject);
    procedure LeaveClick(Sender: TObject);
    procedure JoinClick(Sender: TObject);
    procedure sendClick(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure resKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure nameKeyPress(Sender: TObject; var Key: Char);
    procedure resKeyPress(Sender: TObject; var Key: Char);
    procedure Enter1Click(Sender: TObject);
    procedure Enter2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    N3L:TNNNetworkSession;
    hideID:Boolean;
    enterSend:Boolean;

    netstat:Integer;    //0:ڑ
                        //1:ڑs
                        //2:ڑ
    plrStat:Array[0..plrCnt-1] of Integer;      //-2:
                                                //-1:ItC
                                                //0,1,2...:
    procedure ResetStat;
    procedure onConnect;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ID1Click(Sender: TObject);
begin
    hideID:=not hideID;
    ID1.Checked:=hideID;
end;

procedure TForm1.MainTimerTimer(Sender: TObject);
var i:integer;
    lcr:string;
    procedure Receive;
    var j:integer;
        ptr:Pointer;
        str,str2:String;
        cmd:Integer;
    begin
        if N3L.BlockCount(i)>0 then begin
            For j:=0 to N3L.BlockCount(i)-1 do begin
                //f[^Ⴄ
                ptr:=N3L.GetBlock(i,cmd);
                //f[^WJ
                UnPack(ptr,'tt',[@str,@str2]);
                //f[^
                FreeMem(ptr);
                //JLR
                view.Lines.Add(str);
                view.Lines.Add(str2);
                //ݐXV
                plrStat[i]:=plrStat[i]+1;
            end;
            list.Items[i]:=
                '['+IntToStr(i)+']IC:'+
                    IntToStr(plrStat[i]);
        end;
    end;
begin
    Case netstat of
        0:begin
            //ɂ鎖
        end;
        1:begin
            //ڑs
            lcr:=N3L.LastCloseReason;
            if lcr<>'' then begin
                ResetStat;
                showmessage('ڑs܂B('+lcr+')');
                Exit;
            end;
            //ڑł
            if N3L.Online(0) then begin
                onConnect;
                showmessage('ڑł܂B');
            end;
        end;
        2:begin
            //ڑ؂ꂽ
            if not N3L.Online(0) then begin
                ResetStat;
                showmessage('ڑ؂܂B');
                Exit;
            end;
            //ڑԊĎ
            For i:=0 to plrCnt-1 do begin
                //؂Ă邩
                if not N3L.Online(i) then begin
                    //܂ŌqĂi평
                    if plrStat[i]<>-1 then begin
                        list.Items[i]:='['+IntToStr(i)+']ItC';
                        plrStat[i]:=-1; //؂ꂽ
                    end;
                end else begin
                //؂ĂȂȂ
                    //Vq
                    if plrStat[i]<0 then begin
                        plrStat[i]:=0;  //qĂ
                        list.Items[i]:=
                            '['+IntToStr(i)+']IC:'+
                                IntToStr(plrStat[i]);
                    end;
                    //f[^M
                    Receive;
                end;
            end;
        end;
    end;
end;

procedure TForm1.ResetStat;
var i:integer;
begin
    //Ԃ߂
    netstat:=0;
    //^C}[Ƃ߂
    MainTimer.Enabled:=False;
    //{^֎~
    send.Enabled:=False;
    //j[
    Open.Enabled:=True;
    Close.Enabled:=True;
    Join.Enabled:=True;
    Leave.Enabled:=True;
    //ڑ
    For i:=0 to plrCnt-1 do begin
        plrStat[i]:=-2; //
    end;
    list.Items.Text:=' ';
end;

procedure TForm1.onConnect;
begin
    //Ԃ2ɂ
    netstat:=2;
    //^C}[܂킷
    MainTimer.Enabled:=True;
    //{^
    send.Enabled:=True;
    //j[֎~
    Open.Enabled:=False;
    Join.Enabled:=False;
    //T[o[H
    if N3L.MyID=0 then begin
    //T[o[
        Close.Enabled:=True;
        Leave.Enabled:=False;
    end else begin
    //NCAg
        Close.Enabled:=False;
        Leave.Enabled:=True;
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    N3L:=TNNNetworkSession.Create;
    enterSend:=True;
    //񏉊
    ResetStat;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    N3L.Free;
end;

procedure TForm1.OpenClick(Sender: TObject);
begin
    showmessage('ZbVJn܂B');
    N3L.OpenSession(plrCnt);
    //ڑԂ
    onConnect;
end;

procedure TForm1.CloseClick(Sender: TObject);
begin
    N3L.CloseSession;
end;

procedure TForm1.LeaveClick(Sender: TObject);
begin
    N3L.LeaveSession;
end;

procedure TForm1.JoinClick(Sender: TObject);
var ip:string;
begin
    ip:=InputBox('IP','T[o[IP͂Ă','');
    //{bNX̌ʂ
    if ip='' then begin
    //ہALZ
    end else begin
        showmessage('ڑ܂B');
        N3L.JoinSession(ip);
        //Ԃݒ
        netstat:=1;
        //^C}[܂킷
        MainTimer.Enabled:=True;
        //j[֎~
        Open.Enabled:=False;
        Close.Enabled:=False;
        Join.Enabled:=False;
        Leave.Enabled:=False;   //3b炢҂
    end;
end;

procedure TForm1.sendClick(Sender: TObject);
var ptr:Pointer;//f[^ɕK{
    size:Integer;//łf[^̃TCY
    i:integer;
    str,str2:String;
begin
    //O`FbN
    if Length(name.Text)>64 then begin
        showmessage('O܂B');
        Exit;
    end;
    //`FbN
    if Length(res.Lines.Text)>4096 then begin
        showmessage('݂܂B');
        Exit;
    end;
    //ۃ`FbN
    if res.Lines.Text='' then begin
        showmessage('ݓeۂłB');
        Exit;
    end;
    //s`FbN
    if res.Lines.Count>30 then begin
        showmessage('s܂B');
        Exit;
    end;
    //s`FbN
    For i:=0 to res.Lines.Count-1 do begin
        if Length(res.Lines[i])>256 then begin
            showmessage(IntToStr(i+1)+'sڂ܂B');
            Exit;
        end;
        //łɐ`
        res.Lines[i]:='@@'+res.Lines[i];
    end;

    //^Cgs
    str:='OF';
    //Ȃ
    if name.Text='' then begin
        str:=str+'ȉAɂ܂VIP肵܂';
    end else begin
        str:=str+name.Text;
    end;
    str:=str+' eF'+TimeToStr(now)+' ID:';
    if hideID then begin
        str:=str+'?';
    end else begin
        str:=str+IntToStr(N3L.MyID);
    end;
    str2:=res.Lines.Text+#13#10;//ŌɈs
    //f[^
    size:=Pack(ptr,'tt',[@str,@str2]);
    //݂ȂɑM
    N3L.SetBlockMulti([0,1,2,3,4,5,6,7],0,ptr,size);
    //f[^
    FreeMem(ptr,size);
    //ݗ
    res.Lines.Clear;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
    OKBottomDlg.Show;
end;

procedure TForm1.resKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (ssShift in Shift)or(ssCtrl in Shift) then begin
        if Key=VK_RETURN then begin
            res.Tag:=1;
        end;
    end;
end;

procedure TForm1.nameKeyPress(Sender: TObject; var Key: Char);
begin
  if (Key = Chr(VK_RETURN)) then
    Key := #0;
end;

procedure TForm1.resKeyPress(Sender: TObject; var Key: Char);
    procedure LinkSendButton;
    begin
        if Key=Chr(VK_RETURN) then begin
            if netstat=2 then begin
                sendClick(Form1);
            end;
            Key:=#0;
        end;
    end;
begin
    if res.Tag=0 then begin
        if enterSend then begin
            LinkSendButton;
        end;
    end else begin
        if not enterSend then begin
            LinkSendButton;
        end;
        res.Tag:=0;
    end;
end;

procedure TForm1.Enter1Click(Sender: TObject);
begin
    enterSend:=True;
    Enter1.Checked:=True;
    Enter2.Checked:=False;
end;

procedure TForm1.Enter2Click(Sender: TObject);
begin
    enterSend:=False;
    Enter1.Checked:=False;
    Enter2.Checked:=True;
end;

end.
